Maximum Number That Sum of the Prices Is Less Than or Equal to K |Brute Force |Optimal |Contest 380
Whatsapp Community Link : https://www.whatsapp.com/channel/0029Va6kVSjICVfiVdsHgi1A
This is the 9th Video of our Playlist "Bit-Manipulation : Popular Interview Problems".
In this video we will try to solve an extremely good Bit Manipulation problem with a magic of Binary Search - Maximum Number That Sum of the Prices Is Less Than or Equal to K (Leetcode 3007)
I will explain the intuition so easily that you will never forget and start seeing this as cakewalk EASYYY.
We will do live coding after explanation and see if we are able to pass all the test cases.
Also, please note that my Github solution link below contains both C++ as well as JAVA code.
Problem Name : Maximum Number That Sum of the Prices Is Less Than or Equal to K (Leetcode 3007)
Company Tags : will soon update
My solutions on Github(C++ & JAVA) : https://github.com/MAZHARMIK/Interview_DS_Algo/blob/master/Bit_Magic/Maximum%20Number%20That%20Sum%20of%20the%20Prices%20Is%20Less%20Than%20or%20Equal%20to%20K.cpp
Leetcode Link : https://leetcode.com/problems/maximum-number-that-sum-of-the-prices-is-less-than-or-equal-to-k/description/
Bit Manipulation Playlist - https://www.youtube.com/watch?v=Gx4-uOkopMA&list=PLpIkg8OmuX-I-t2eiSxfO0UjiLhmNGfon
My DP Concepts Playlist : https://youtu.be/7eLMOE1jnls
My Graph Concepts Playlist : https://youtu.be/5JGiZnr6B5w
My GitHub Repo for interview preparation : https://github.com/MAZHARMIK/Interview_DS_Algo
Subscribe to my channel : https://www.youtube.com/@codestorywithMIK
Instagram : https://www.instagram.com/codestorywithmik/
Facebook : https://www.facebook.com/people/codestorywithmik/100090524295846/
Twitter : https://twitter.com/CSwithMIK
Approach Summary (Brute Force) : Try with all numbers and find their price sum and as soon as the price sum exceeds k, stop and return the last valid number.
Approach Summary (Optimal) : The getBits function calculates the count of set bits (1s) at each position in the binary representation of a given number. It utilizes a recursive approach to determine these counts for powers of 2 and their respective positions. The findMaximumNumber function uses binary search to find the maximum number within a specified range. It iteratively adjusts the range based on the accumulated count of set bits at positions divisible by a given divisor. The goal is to find a number such that the accumulated count is below a specified threshold. Overall, the solution employs binary search and bit manipulation to efficiently find a maximum number with specific binary properties within a given range.
╔═╦╗╔╦╗╔═╦═╦╦╦╦╗╔═╗
║╚╣║║║╚╣╚╣╔╣╔╣║╚╣═╣
╠╗║╚╝║║╠╗║╚╣║║║║║═╣
╚═╩══╩═╩═╩═╩╝╚╩═╩═╝
✨ Timelines✨
00:00 - Introduction
#coding #helpajobseeker #easyrecipes #leetcode #leetcodequestionandanswers #leetcodesolution #leetcodedailychallenge #leetcodequestions #leetcodechallenge #hindi #india #coding #helpajobseeker #easyrecipes #leetcode #leetcodequestionandanswers #leetcodesolution #leetcodedailychallenge#leetcodequestions #leetcodechallenge #hindi #india #hindiexplanation #hindiexplained #easyexplaination #interview#interviewtips #interviewpreparation #interview_ds_algo #hinglish #github #design #data #google #video #instagram #facebook #leetcode #computerscience #leetcodesolutions #leetcodequestionandanswers #code #learning #dsalgo #dsa #2024 #newyear